% Basic integrate-and-fire neuron 
% R Rao 1999  (adapted for 590rr)

clear
% input current
I = 1; % nA  1

% capacitance and leak resistance
C = 1; % nF  1
R = 40; % M ohms  40

% I & F implementation dV/dt = - V/RC + I/C
% Using h = 1 ms step size, Euler method

V = 0;
tstop = 200;
abs_ref = 5; % absolute refractory period 5
ref = 0; % absolute refractory period counter
V_trace = []; % voltage trace for plotting
V_th = 10; % spike threshold  10
V_spike = 50;

for t = 1:tstop
  
   if ~ref
     V = V - (V/(R*C)) + (I/C);
   else
     ref = ref - 1;
     V = 0.2*V_th; % reset voltage
   end
   
   if (V > V_th)
     V = V_spike;  % emit spike
     ref = abs_ref; % set refractory counter
   end

   V_trace = [V_trace V];

end

figure(1);
plot(V_trace);
axis([0 tstop 0 V_spike]);
xlabel('Time (ms)');
ylabel('Voltage (artificial units)');
